using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.Charting;
using System.Text.RegularExpressions;
using System.Diagnostics;

namespace CustomRanges
{
    public partial class Form1 : Form
    {
        List<string> results = new List<string>();

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.radChart1.PlotArea.YAxis.Appearance.ValueFormat = Telerik.Charting.Styles.ChartValueFormat.ShortDate;
            this.radChart1.PlotArea.YAxis.Appearance.CustomFormat = "ddd, MMM dd";
            this.radChart1.PlotArea.YAxis.Appearance.LabelAppearance.RotationAngle = 90;
            this.radChart1.PlotArea.YAxis.Appearance.LabelAppearance.Position.AlignedPosition = Telerik.Charting.Styles.AlignedPositions.Top;
            this.radChart1.Series.Clear();

            this.radChart1.PlotArea.YAxis.IsZeroBased = false;
            
            // Set the range to the current month:

            //this.radChart1.PlotArea.YAxis.AutoScale = false;
            //DateTime from = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1, 0, 0, 0, 0);
            //// add month to obtain next month, and decrease by one day to get last day of the month.
            //DateTime to = from.AddMonths(1).AddDays(-1); 
            //this.radChart1.PlotArea.YAxis.AddRange(from.ToOADate(), to.ToOADate(), 1);

            // DataBind
            this.radChart1.DataSource = CreateSource();
            ChartSeries series = new ChartSeries();

            series.Type = ChartSeriesType.Gantt;
            series.Appearance.LabelAppearance.Visible = false;
            series.DataYColumn = "From";
            series.DataYColumn2 = "To";
            this.radChart1.Series.Add(series);

            this.radChart1.SeriesOrientation = ChartSeriesOrientation.Horizontal;

            this.radChart1.PlotArea.XAxis.DataLabelsColumn = "Name";
            this.radChart1.DataBind();
        }

        private static DataTable CreateSource()
        {
            string[] names = new string[] { "John", "Peter", "Yamamoto", "Hiru", "Blessenohl" };
            Random rand = new Random();

            DataTable table = new DataTable();
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("From", typeof(double));
            table.Columns.Add("To", typeof(double));

            DateTime monthStart = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);

            for (int i = 0; i < names.Length; i++)
            {
                DateTime from = monthStart.AddDays(rand.Next(0, 20));
                DateTime to = from.AddDays(rand.Next(5, 30));
                DataRow row = table.NewRow();
                row["Name"] = names[i];
                row["From"] = Math.Round(from.ToOADate());
                row["To"] = Math.Round(to.ToOADate());
                table.Rows.Add(row);
            }

            return table;
        }
    }
}